<template>
  <v-data-table
    :headers="headers"
    :items="dataObj"
    :items-per-page="20"
    :sort-by="['date', 'no']"
    :sort-desc="[true, false]"
    multi-sort
    class="elevation-5"
  >
    <template #item.date="{ item }">
      <span>{{ new Date(item.date).toISOString().substr(0, 10) }}</span>
    </template>
    <template #item.price="{ item }">
      <span>{{
        parseInt(item.price).toLocaleString('th-TH', {
          style: 'currency',
          currency: 'THB',
        })
      }}</span>
    </template>
    <template #item.action="{ item }">
      <v-tooltip v-if="item.doc != '-'" bottom>
        <template v-slot:activator="{ on, attrs }">
          <v-btn
            class="mr-1 mb-2"
            color="green darken-2"
            v-bind="attrs"
            v-on="on"
            small
            dark
            :href="item.doc"
            target="_blank"
          >
            <v-icon icon small dark> mdi-image-multiple-outline </v-icon>
          </v-btn>
        </template>
        <span>เอกสาร</span>
      </v-tooltip>
    </template>
  </v-data-table>
</template>
<script>
import covertDate from '@/mixins/formateDate'
import { mapGetters, mapActions, mapState } from 'vuex'

export default {
  mixins: [covertDate],
  data() {
    return {
      headers: [
        {
          text: 'หมายเลขบิล',
          value: 'no',
        },
        { text: 'ชื่อร้าน', value: 'name' },
        { text: 'วันที่', value: 'date' },
        { text: 'รวม', value: 'price' },
        { text: 'เครื่องมือ', value: 'action' },
      ],
      dataObj: [],
    }
  },
  watch: {
    getExpensesTable() {
      this.testFunction(this.$nuxt.$store.state.expensestable.ExpensesTable)
    },
  },
  computed: {
    ...mapState({
      getExpensesTable: (state) => state.expensestable.ExpensesTable,
    }),
  },
  mounted() {
    this.callTableAll()
  },

  methods: {
    ...mapActions({
      callTableAll: 'callTableAll',
    }),
    testFunction(exTable) {
      const minVal = exTable.reduce((prev, cur) =>
        cur.date < prev.date ? cur : prev
      )
      const lastDate = new Date(minVal.date).getTime()
      const getLastDate = new Date(
        new Date().toISOString().substr(0, 10)
      ).getTime()

      const dataRes = this.totalTypeMulti(exTable, lastDate, getLastDate)
      this.dataObj = dataRes.sort((a, b) =>
        a.date > b.date ? -1 : a.date < b.date ? 1 : 0
      )
    },
    totalTypeMulti(dataRes, dataStart, dateEnd) {
      const dateFunction = this.filterdate(dataRes, dataStart, dateEnd)

      // จัดกรุ๊ปใหม่
      let newObj = []
      dateFunction.forEach((data) => {
        newObj = [
          ...newObj,
          {
            id: data.id,
            no: data.no,
            doc: data.doc,
            name: data.storesExpenses.name,
            date: new Date(data.date).getTime(),
            price: data.price,
          },
        ]
      })
      // คำนวนผลรวมแยกตาม วันที่ และ ไอดี ประเภทค่าใช้จ่าย
      var helper = {}
      var resultVal = newObj.reduce(function (prev, cur) {
        var key = cur.date + '-' + cur.no

        if (!helper[key]) {
          helper[key] = Object.assign({}, cur) // create a copy of o
          prev.push(helper[key])
        } else {
          helper[key].price += cur.price
        }
        return prev
      }, [])
      return resultVal
    },
    filterdate(dataRes, dataStart, dateEnd) {
      let firstDate = parseInt(dataStart)
      let lastDate = parseInt(dateEnd) + 86390000
      const dateFind = dataRes.filter((dataval) => {
        return (
          new Date(dataval.date).getTime() >= firstDate &&
          new Date(dataval.date).getTime() <= lastDate
        )
      })

      return dateFind
    },
  },
}
</script>
